/**
 * PETALS - PETALS Services Platform. Copyright (C) 2005 EBM WebSourcing
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: ComponentLifeCycleMBean.java,v 1.2 2005/07/22 10:24:27 alouis Exp $
 * 
 */

package org.ow2.petals.container.lifecycle;

import java.util.Map;

import javax.jbi.JBIException;

import org.ow2.petals.container.thread.ComponentLifeCycleThread;
import org.ow2.petals.jbi.component.context.ComponentContextImpl;
import org.ow2.petals.kernel.api.server.PetalsException;

/**
 * The <code>ComponentLifeCycle</code> interface has to have its mbean interface
 * in the same package as it.
 * 
 * @author Adrien LOUIS - EBM WebSourcing
 */
public interface ComponentLifeCycleInterface {

    /**
     * Initialization of ComponentLifeCycleMBean
     * 
     * @param componentDescription
     *            the component description
     * @param componentContext
     *            the component Context
     * @param component
     *            the component
     * @param mbeanName
     *            the mbean name
     * @param componentLifeCycleThread
     *            the thread of the component life cycle
     * @param log
     *            the log
     * @param context
     *            the context
     * @throws PetalsException
     *             occurs when it is impossible to init the component life cycle
     */
    void init(ComponentContextImpl componentContext,
            ComponentLifeCycleThread componentLifeCycleThread, Map<String, Object> context)
            throws PetalsException, JBIException;
}
