/*
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package org.ow2.petals.platform.repository.artifact;

import java.io.File;
import java.util.List;

import org.ow2.petals.kernel.api.server.PetalsException;

/**
 * The artifact repository is used to have a reference on some JBI artefacts.
 * 
 * @author Christophe HAMERLING - eBM WebSourcing
 * 
 */
public interface ArtifactRepositoryService {

    /**
     * Get the artifact repository root path
     * 
     * @return
     */
    File getRootPath();

    /**
     * 
     * @return
     */
    File getComponentsPath();

    /**
     * 
     * @return
     */
    File getServiceAssemblyPath();

    /**
     * 
     * @return
     */
    File getSharedLibraryPath();

    /**
     * Get the list of components which are available in the repository
     * 
     * @return
     */
    List<Artifact> getComponents();

    /**
     * 
     * @return
     */
    public List<String> getComponentsName();

    /**
     * 
     * @return
     */
    List<Artifact> getServiceAssemblies();

    /**
     * 
     * @return
     */
    public List<String> getServiceAssembliesName();

    /**
     * 
     * @return
     */
    List<Artifact> getSharedLibraries();

    /**
     * 
     * @return
     */
    public List<String> getSharedLibrariesName();

    /**
     * Add the artifact to the repository
     * 
     * @param artifact
     * @return
     */
    boolean addArtifact(Artifact artifact) throws PetalsException;

}
